Index: branches/new_class_id/src/story_entities/game_world.cc
===================================================================
--- branches/new_class_id/src/story_entities/game_world.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/game_world.cc	(revision 9709)
@@ -22,5 +22,4 @@
 #include "util/loading/resource_manager.h"
 #include "state.h"
-#include "class_list.h"
 
 #include "util/loading/game_loader.h"
@@ -40,5 +39,5 @@
 #include "util/loading/factory.h"
 #include "util/loading/load_param.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "shell_command.h"
 
@@ -63,5 +62,6 @@
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(GameWorld, CL_GAME_WORLD,
+NewObjectListDefinition(GameWorld);
+CREATE_SCRIPTABLE_CLASS(GameWorld, GameWorld::classID(),
                         addMethod("setPlaymode", ExecutorLua1<GameWorld,const std::string&>(&GameWorld::setPlaymode))
                         ->addMethod("setSoundtrack", ExecutorLua1<GameWorld, const std::string&>(&GameWorld::setSoundtrack))
@@ -77,9 +77,8 @@
 
 
-
 GameWorld::GameWorld()
     : StoryEntity()
 {
-  this->setClassID(CL_GAME_WORLD, "GameWorld");
+  this->registerObject(this, GameWorld::_objectList);
   this->setName("Preloaded World - no name yet");
 
@@ -432,5 +431,5 @@
     // TICK everything
     for (i = 0; i < this->dataTank->tickLists.size(); ++i)
-      this->tick(this->dataTank->objectManager->getObjectList(this->dataTank->tickLists[i]), this->dtS);
+      this->tick(this->dataTank->objectManager->getEntityList(this->dataTank->tickLists[i]), this->dtS);
 
     /* update tick the rest */
@@ -471,25 +470,25 @@
 {
   // object-object collision detection
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
-      this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-      this->dataTank->objectManager->getObjectList(OM_GROUP_00_PROJ));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-      this->dataTank->objectManager->getObjectList(OM_GROUP_00));
-
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-      this->dataTank->objectManager->getObjectList(OM_GROUP_02));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_02),
-      this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
-
-
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
-      this->dataTank->objectManager->getObjectList(OM_COMMON));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-      this->dataTank->objectManager->getObjectList(OM_COMMON));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_00),
+      this->dataTank->objectManager->getEntityList(OM_GROUP_01_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+      this->dataTank->objectManager->getEntityList(OM_GROUP_00_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+      this->dataTank->objectManager->getEntityList(OM_GROUP_00));
+
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+      this->dataTank->objectManager->getEntityList(OM_GROUP_02));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_02),
+      this->dataTank->objectManager->getEntityList(OM_GROUP_01_PROJ));
+
+
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_00),
+      this->dataTank->objectManager->getEntityList(OM_COMMON));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+      this->dataTank->objectManager->getEntityList(OM_COMMON));
 
   // ground collision detection: BSP Model
-  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getObjectList(OM_GROUP_00));
-  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getObjectList(OM_GROUP_01));
+  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getEntityList(OM_GROUP_00));
+  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getEntityList(OM_GROUP_01));
 }
 
@@ -567,32 +566,29 @@
   //  glLoadIdentity();
 
-  const std::list<BaseObject*>* reflectedWaters;
   MappedWater* mw;
 
-  if( (reflectedWaters = ClassList::getList(CL_MAPPED_WATER)) != NULL)
-  {
-    std::list<BaseObject*>::const_iterator it;
-    for (it = reflectedWaters->begin(); it != reflectedWaters->end(); it++)
-    {
-      mw =  dynamic_cast<MappedWater*>(*it);
-
-      //camera and light
-      //this->dataTank->localCamera->apply ();
-      //this->dataTank->localCamera->project ();
-
-      LightManager::getInstance()->draw();
-
-
-      // prepare for reflection rendering
-      mw->activateReflection();
-
-      // draw everything to be included in the reflection
-      this->drawEntityList(State::getObjectManager()->getReflectionList());
-      //       for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
-      //         this->drawEntityList(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]));
-
-      // clean up from reflection rendering
-      mw->deactivateReflection();
-    }
+  for (NewObjectList<MappedWater>::const_iterator it = MappedWater::objectList().begin();
+       it != MappedWater::objectList().end();
+       ++it)
+  {
+    mw =  (*it);
+
+    //camera and light
+    //this->dataTank->localCamera->apply ();
+    //this->dataTank->localCamera->project ();
+
+    LightManager::getInstance()->draw();
+
+
+    // prepare for reflection rendering
+    mw->activateReflection();
+
+    // draw everything to be included in the reflection
+    this->drawEntityList(State::getObjectManager()->getReflectionList());
+    //       for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
+    //         this->drawEntityList(State::getObjectManager()->getEntityList(this->dataTank->drawLists[i]));
+
+    // clean up from reflection rendering
+    mw->deactivateReflection();
   }
 
@@ -609,30 +605,27 @@
   //glLoadIdentity();
 
-  const std::list<BaseObject*>* reflectedWaters;
   MappedWater* mw;
 
-  if( (reflectedWaters = ClassList::getList(CL_MAPPED_WATER)) != NULL)
-  {
-    std::list<BaseObject*>::const_iterator it;
-    for (it = reflectedWaters->begin(); it != reflectedWaters->end(); it++)
-    {
-      mw =  dynamic_cast<MappedWater*>(*it);
-
-      //camera and light
-      //this->dataTank->localCamera->apply ();
-      //this->dataTank->localCamera->project ();
-      // prepare for reflection rendering
-      mw->activateRefraction();
-
-
-      LightManager::getInstance()->draw();
-      // draw everything to be included in the reflection
-      this->drawEntityList(State::getObjectManager()->getReflectionList());
-      //       for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
-      //         this->drawEntityList(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]));
-
-      // clean up from reflection rendering
-      mw->deactivateRefraction();
-    }
+  for (NewObjectList<MappedWater>::const_iterator it = MappedWater::objectList().begin();
+       it != MappedWater::objectList().end();
+       ++it)
+  {
+    mw =  dynamic_cast<MappedWater*>(*it);
+
+    //camera and light
+    //this->dataTank->localCamera->apply ();
+    //this->dataTank->localCamera->project ();
+    // prepare for reflection rendering
+    mw->activateRefraction();
+
+
+    LightManager::getInstance()->draw();
+    // draw everything to be included in the reflection
+    this->drawEntityList(State::getObjectManager()->getReflectionList());
+    //       for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
+    //         this->drawEntityList(State::getObjectManager()->getEntityList(this->dataTank->drawLists[i]));
+
+    // clean up from reflection rendering
+    mw->deactivateRefraction();
   }
 }
@@ -659,10 +652,10 @@
   {
     /* Draw the BackGround */
-    this->drawEntityList(State::getObjectManager()->getObjectList(OM_BACKGROUND));
+    this->drawEntityList(State::getObjectManager()->getEntityList(OM_BACKGROUND));
     engine->drawBackgroundElements();
 
     /* draw all WorldEntiy groups */
     for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
-      this->drawEntityList(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]));
+      this->drawEntityList(State::getObjectManager()->getEntityList(this->dataTank->drawLists[i]));
 
     AtmosphericEngine::getInstance()->draw();
@@ -672,5 +665,5 @@
       CDEngine* engine = CDEngine::getInstance();
       for (unsigned int i = 0; i < this->dataTank->drawLists.size(); ++i)
-        engine->drawBV(State::getObjectManager()->getObjectList(this->dataTank->drawLists[i]), this->showBVLevel);
+        engine->drawBV(State::getObjectManager()->getEntityList(this->dataTank->drawLists[i]), this->showBVLevel);
     }
 
Index: branches/new_class_id/src/story_entities/game_world.h
===================================================================
--- branches/new_class_id/src/story_entities/game_world.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/game_world.h	(revision 9709)
@@ -31,4 +31,6 @@
 class GameWorld : public StoryEntity
 {
+  NewObjectListDeclaration(GameWorld);
+
 public:
   GameWorld ();
Index: branches/new_class_id/src/story_entities/game_world_data.cc
===================================================================
--- branches/new_class_id/src/story_entities/game_world_data.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/game_world_data.cc	(revision 9709)
@@ -23,5 +23,4 @@
 #include "util/loading/resource_manager.h"
 #include "state.h"
-#include "class_list.h"
 #include "substring.h"
 
@@ -41,8 +40,9 @@
 
 #include "util/loading/factory.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "util/loading/load_param.h"
 
 #include "graphics_engine.h"
+#include "effects/graphics_effect.h"
 #include "effects/atmospheric_engine.h"
 #include "event_handler.h"
@@ -61,7 +61,5 @@
 
 
-
-
-
+NewObjectListDefinition(GameWorldData);
 /**
  * constructor of the GameWorldData
@@ -69,5 +67,5 @@
 GameWorldData::GameWorldData()
 {
-  this->setClassID(CL_GAME_WORLD_DATA, "GameWorldData");
+  this->registerObject(this, GameWorldData::_objectList);
 
   this->glmis = NULL;
@@ -215,10 +213,10 @@
 
       //todo do this more elegant
-      if( element->Value() == "SkyBox" && created->isA(CL_SKYBOX))
+      if( element->Value() == "SkyBox" && created->isA(SkyBox::classID()))
       {
         this->sky = dynamic_cast<WorldEntity*>(created);
         State::setSkyBox(dynamic_cast<SkyBox*>(this->sky));
       }
-      if( element->Value() == "Terrain" && created->isA(CL_TERRAIN))
+      if( element->Value() == "Terrain" && created->isA(Terrain::classID()))
       {
         this->terrain = dynamic_cast<Terrain*>(created);
@@ -236,10 +234,8 @@
 
   Playable* playable;
-  const std::list<BaseObject*>* playableList = ClassList::getList(CL_PLAYABLE);
-  if (playableList != NULL && !playableList->empty())
+  if (!Playable::objectList().empty())
   {
     /// TODO Make this also loadable
-    playable = dynamic_cast<Playable*>(playableList->front());
-    this->localPlayer->setPlayable(playable);
+    this->localPlayer->setPlayable(Playable::objectList().back());
   }
 
@@ -280,16 +276,8 @@
   GraphicsEngine::getInstance()->displayFPS(false);
   // erease everything that is left.
-  // delete PNode::getNullParent(); // not needed as this is also done in the next step (and also much cleaner)
-  const std::list<BaseObject*>* nodeList;
   //secondary cleanup of PNodes;
-  nodeList = ClassList::getList(CL_PARENT_NODE);
-  if (nodeList != NULL)
-    while (!nodeList->empty())
-    {
-      //    ClassList::debug( 3, CL_PARENT_NODE);
-      //    PNode::getNullParent()->debugNode(0);
-      //    printf("%s::%s\n", nodeList->front()->getClassCName(), nodeList->front()->getName());
-      delete nodeList->front();
-    }
+  while (!PNode::objectList().empty())
+    delete PNode::objectList().front();
+
   /* remove the player object */
   if( this->localPlayer)
@@ -302,14 +290,10 @@
   this->terrain = NULL;
 
-  nodeList = ClassList::getList(CL_GRAPHICS_EFFECT);
-  if (nodeList != NULL)
-    while (!nodeList->empty())
-      delete nodeList->front();
-
-
-  nodeList = ClassList::getList(CL_ELEMENT_2D);
-  if (nodeList != NULL)
-    while (!nodeList->empty())
-      delete nodeList->front();
+  while (!GraphicsEffect::objectList().empty())
+    delete GraphicsEffect::objectList().front();
+
+
+  while (!Element2D::objectList().empty())
+    delete Element2D::objectList().front();
 
   // At this Point all the WorldEntites should be unloaded.
@@ -414,5 +398,5 @@
     PRINTF(2)("creating %s\n", element->Value());
     BaseObject* created = Factory::fabricate(element);
-    if (created != NULL && created->isA(CL_GAME_RULES))
+    if (created != NULL && created->isA(GameRules::classID()))
     {
       this->gameRule = dynamic_cast<GameRules*>(created);
Index: branches/new_class_id/src/story_entities/game_world_data.h
===================================================================
--- branches/new_class_id/src/story_entities/game_world_data.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/game_world_data.h	(revision 9709)
@@ -30,4 +30,5 @@
 class GameWorldData : public DataTank
 {
+  NewObjectListDeclaration(GameWorldData);
   public:
     GameWorldData();
Index: branches/new_class_id/src/story_entities/menu/game_menu.cc
===================================================================
--- branches/new_class_id/src/story_entities/menu/game_menu.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/menu/game_menu.cc	(revision 9709)
@@ -22,5 +22,4 @@
 
 #include "state.h"
-#include "class_list.h"
 
 #include "util/loading/load_param.h"
@@ -43,7 +42,8 @@
 #include "preferences.h"
 
+#include "class_id.h"
 //! This creates a Factory to fabricate a GameMenu
-CREATE_FACTORY(GameMenu, CL_GAME_MENU);
-
+NewObjectListDefinitionID(GameMenu, CL_GAME_MENU);
+CREATE_FACTORY(GameMenu);
 
 
@@ -51,5 +51,5 @@
     : GameWorld()
 {
-  this->setClassID(CL_GAME_MENU, "GameMenu");
+  this->registerObject(this, GameMenu::_objectList);
   this->setName("GameMenu uninitialized");
 
@@ -191,10 +191,10 @@
       image->setForegroundColor(Color( 1,1,1,.6));
 
-      const std::list<BaseObject*>* storyEntities = ClassList::getList(CL_STORY_ENTITY);
-      std::list<BaseObject*>::const_iterator it;
       bool first = true;
-      for( it = storyEntities->begin(); it != storyEntities->end(); it++)
+      for(NewObjectList<StoryEntity>::const_iterator it = StoryEntity::objectList().begin();
+	  it != StoryEntity::objectList().end();
+	  ++it)
       {
-        StoryEntity* se = dynamic_cast<StoryEntity*>(*it);
+        StoryEntity* se = *it;
         if( se->isContainedInMenu())
         {
Index: branches/new_class_id/src/story_entities/menu/game_menu.h
===================================================================
--- branches/new_class_id/src/story_entities/menu/game_menu.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/menu/game_menu.h	(revision 9709)
@@ -22,5 +22,5 @@
 class GameMenu : virtual public GameWorld, virtual public EventListener
 {
-
+  NewObjectListDeclaration(GameMenu);
   public:
     GameMenu(const TiXmlElement* root = NULL);
@@ -45,8 +45,8 @@
     void showMultiPlayer();
     void showOptionsMenu();
-    
+
     void showClientMenu();
     void connectToServer();
-    
+
     void showServerMenu();
     void createMasterServer();
@@ -69,5 +69,5 @@
     void setSelectorSound(const std::string& selectorSound);
 
-    
+
 
 
@@ -76,8 +76,8 @@
     OrxGui::GLGuiBox*                 levelsBox;
     OrxGui::GLGuiBox*                 networkBox;
-    
+
     OrxGui::GLGuiBox*                 clientNetworkBox;
     OrxGui::GLGuiInputLine*           ipInputLine;
-    
+
     OrxGui::GLGuiBox*                 serverNetworkBox;
 
Index: branches/new_class_id/src/story_entities/movie_loader.cc
===================================================================
--- branches/new_class_id/src/story_entities/movie_loader.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/movie_loader.cc	(revision 9709)
@@ -25,10 +25,11 @@
 
 
-
-CREATE_FACTORY(MovieLoader, CL_MOVIE_LOADER);
+#include "class_id.h"
+NewObjectListDefinitionID(MovieLoader, CL_MOVIE_LOADER);
+CREATE_FACTORY(MovieLoader);
 
 MovieLoader::MovieLoader(const TiXmlElement* root)
 {
-  this->setClassID(CL_MOVIE_LOADER, "MovieLoader");
+  this->registerObject(this, MovieLoader::_objectList);
 
   movie_player = new MoviePlayer();
Index: branches/new_class_id/src/story_entities/movie_loader.h
===================================================================
--- branches/new_class_id/src/story_entities/movie_loader.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/movie_loader.h	(revision 9709)
@@ -15,4 +15,5 @@
 class MovieLoader : public StoryEntity, virtual public EventListener
 {
+  NewObjectListDeclaration(MovieLoader);
   private:
     MoviePlayer* movie_player;
Index: branches/new_class_id/src/story_entities/multi_player_world.cc
===================================================================
--- branches/new_class_id/src/story_entities/multi_player_world.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/multi_player_world.cc	(revision 9709)
@@ -36,13 +36,13 @@
 SHELL_COMMAND(debug, MultiPlayerWorld, debug);
 
-
+#include "class_id.h"
 //! This creates a Factory to fabricate a MultiPlayerWorld
-CREATE_FACTORY(MultiPlayerWorld, CL_MULTI_PLAYER_WORLD);
-
+NewObjectListDefinitionID(MultiPlayerWorld, CL_MULTI_PLAYER_WORLD);
+CREATE_FACTORY(MultiPlayerWorld);
 
 MultiPlayerWorld::MultiPlayerWorld(const TiXmlElement* root)
   : GameWorld()
 {
-  this->setClassID(CL_MULTI_PLAYER_WORLD, "MultiPlayerWorld");
+  this->registerObject(this, MultiPlayerWorld::_objectList);
 
   this->dataTank = new MultiPlayerWorldData();
@@ -95,46 +95,46 @@
 void MultiPlayerWorld::collisionDetection()
 {
-  //CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_PLAYERS), this->dataTank->objectManager->getObjectList(OM_PLAYERS));
+  //CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_PLAYERS), this->dataTank->objectManager->getEntityList(OM_PLAYERS));
 
   PRINTF(5)("\n-----------------------------------------\nchecking OM_PLAYERS vs OM_GROUP_01_PROJ\n\n");
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_PLAYERS),
-    this->dataTank->objectManager->getObjectList(OM_GROUP_00_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_PLAYERS),
+    this->dataTank->objectManager->getEntityList(OM_GROUP_00_PROJ));
   PRINTF(5)("\n-----------------------------------------\nchecking OM_PLAYERS vs OM_GROUP_01_PROJ\n\n");
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_PLAYERS),
-    this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_PLAYERS),
+    this->dataTank->objectManager->getEntityList(OM_GROUP_01_PROJ));
   PRINTF(5)("\n-----------------------------------------\nchecking OM_PLAYERS vs OM_PLAYERS_PROJ\n\n");
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_PLAYERS),
-    this->dataTank->objectManager->getObjectList(OM_PLAYERS_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_PLAYERS),
+    this->dataTank->objectManager->getEntityList(OM_PLAYERS_PROJ));
 
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
-  this->dataTank->objectManager->getObjectList(OM_PLAYERS));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-  this->dataTank->objectManager->getObjectList(OM_PLAYERS));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_00),
+  this->dataTank->objectManager->getEntityList(OM_PLAYERS));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+  this->dataTank->objectManager->getEntityList(OM_PLAYERS));
 
 
 
   PRINTF(5)("\n-----------------------------------------\nchecking OM_GROUP_00 vs OM_GROUP_01_PROJ\n\n");
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
-    this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_00),
+    this->dataTank->objectManager->getEntityList(OM_GROUP_01_PROJ));
   PRINTF(5)("\n-----------------------------------------\nchecking OM_GROUP_00 vs OM_GROUP_01\n\n");
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
-    this->dataTank->objectManager->getObjectList(OM_GROUP_01));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
-    this->dataTank->objectManager->getObjectList(OM_PLAYERS_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_00),
+    this->dataTank->objectManager->getEntityList(OM_GROUP_01));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_00),
+    this->dataTank->objectManager->getEntityList(OM_PLAYERS_PROJ));
 
   PRINTF(5)("\n-----------------------------------------\nchecking OM_GROUP_01 vs OM_GROUP_00_PROJ\n\n");
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-    this->dataTank->objectManager->getObjectList(OM_GROUP_00_PROJ));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-    this->dataTank->objectManager->getObjectList(OM_GROUP_00));
-  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
-    this->dataTank->objectManager->getObjectList(OM_PLAYERS_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+    this->dataTank->objectManager->getEntityList(OM_GROUP_00_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+    this->dataTank->objectManager->getEntityList(OM_GROUP_00));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getEntityList(OM_GROUP_01),
+    this->dataTank->objectManager->getEntityList(OM_PLAYERS_PROJ));
 
 
 
     // ground collision detection: BSP Model
-  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getObjectList(OM_GROUP_00));
-  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getObjectList(OM_GROUP_01));
-  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getObjectList(OM_PLAYERS));
+  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getEntityList(OM_GROUP_00));
+  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getEntityList(OM_GROUP_01));
+  CDEngine::getInstance()->checkCollisionGround(this->dataTank->objectManager->getEntityList(OM_PLAYERS));
 }
 
Index: branches/new_class_id/src/story_entities/multi_player_world.h
===================================================================
--- branches/new_class_id/src/story_entities/multi_player_world.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/multi_player_world.h	(revision 9709)
@@ -20,5 +20,5 @@
  */
 class MultiPlayerWorld : public GameWorld {
-
+  NewObjectListDeclaration(MultiPlayerWorld);
  public:
   MultiPlayerWorld (const TiXmlElement* root = NULL);
@@ -26,5 +26,5 @@
 
   virtual void loadParams(const TiXmlElement* root);
-  
+
   virtual ErrorMessage unloadData();
 
Index: branches/new_class_id/src/story_entities/multi_player_world_data.cc
===================================================================
--- branches/new_class_id/src/story_entities/multi_player_world_data.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/multi_player_world_data.cc	(revision 9709)
@@ -20,5 +20,4 @@
 #include "util/loading/resource_manager.h"
 #include "state.h"
-#include "class_list.h"
 #include "substring.h"
 
@@ -40,5 +39,5 @@
 
 #include "util/loading/factory.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "util/loading/load_param.h"
 
@@ -50,8 +49,4 @@
 
 #include "glmenu_imagescreen.h"
-
-
-
-
 
 
@@ -313,14 +308,12 @@
 {
   PRINT(0)("==================================================\n");
+
   Playable* playable;
-  const std::list<BaseObject*>* playableList = ClassList::getList(CL_PLAYABLE);
-  assert(playableList != NULL);
-  std::list<BaseObject*>::const_iterator entity;
-
-
-
-  for (entity = playableList->begin(); entity != playableList->end(); entity++)
-  {
-    Playable* p = dynamic_cast<Playable*>(*entity);
+
+  for (NewObjectList<Playable>::const_iterator entity = Playable::objectList().begin();
+       entity != Playable::objectList().end();
+      ++entity)
+  {
+    Playable* p = *entity;
     PRINTF(0)("Got a playable, class: %s, name: %s, uid: %i\n", (*entity)->getClassCName(), (*entity)->getCName(), p->getUniqueID());
   }
@@ -329,5 +322,5 @@
   if( this->toggle)
   {
-    playable = dynamic_cast<Playable*>(playableList->front());
+    playable = Playable::objectList().front();
     this->localPlayer->setPlayable(playable);
     this->toggle = !this->toggle;
@@ -335,5 +328,5 @@
   else
   {
-    playable = dynamic_cast<Playable*>(playableList->back());
+    playable = Playable::objectList().back();
     this->localPlayer->setPlayable(playable);
     this->toggle = !this->toggle;
Index: branches/new_class_id/src/story_entities/single_player_world.cc
===================================================================
--- branches/new_class_id/src/story_entities/single_player_world.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/single_player_world.cc	(revision 9709)
@@ -20,8 +20,7 @@
 
 #include "state.h"
-#include "class_list.h"
 
 #include "util/loading/load_param.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "util/loading/factory.h"
 
@@ -30,16 +29,13 @@
 
 
-
-
-
+#include "class_id.h"
 //! This creates a Factory to fabricate a SinglePlayerWorld
-CREATE_FACTORY(SinglePlayerWorld, CL_SINGLE_PLAYER_WORLD);
-
-
+NewObjectListDefinitionID(SinglePlayerWorld, CL_SINGLE_PLAYER_WORLD);
+CREATE_FACTORY(SinglePlayerWorld);
 
 SinglePlayerWorld::SinglePlayerWorld(const TiXmlElement* root)
   : GameWorld()
 {
-  this->setClassID(CL_SINGLE_PLAYER_WORLD, "SinglePlayerWorld");
+  this->registerObject(this, SinglePlayerWorld::_objectList);
   this->setName("SinglePlayerWorld uninitialized");
 
Index: branches/new_class_id/src/story_entities/single_player_world.h
===================================================================
--- branches/new_class_id/src/story_entities/single_player_world.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/single_player_world.h	(revision 9709)
@@ -22,4 +22,5 @@
 class SinglePlayerWorld : public GameWorld
 {
+  NewObjectListDeclaration(SinglePlayerWorld);
 
   public:
Index: branches/new_class_id/src/story_entities/story_entity.cc
===================================================================
--- branches/new_class_id/src/story_entities/story_entity.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/story_entity.cc	(revision 9709)
@@ -27,5 +27,5 @@
 
 
-
+NewObjectListDefinition(StoryEntity);
 
 /**
@@ -34,5 +34,5 @@
 StoryEntity::StoryEntity ()
 {
-  this->setClassID(CL_STORY_ENTITY, "StoryEntity");
+  this->registerObject(this, StoryEntity::_objectList);
 
   this->bInit = false;
Index: branches/new_class_id/src/story_entities/story_entity.h
===================================================================
--- branches/new_class_id/src/story_entities/story_entity.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/story_entity.h	(revision 9709)
@@ -26,4 +26,5 @@
 class StoryEntity : virtual public BaseObject
 {
+  NewObjectListDeclaration(StoryEntity);
 
 public:
Index: branches/new_class_id/src/subprojects/network/simple_sync.cc
===================================================================
--- branches/new_class_id/src/subprojects/network/simple_sync.cc	(revision 9707)
+++ branches/new_class_id/src/subprojects/network/simple_sync.cc	(revision 9709)
@@ -23,5 +23,5 @@
 
 #include "class_id.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "lib/util/loading/factory.h"
 
Index: branches/new_class_id/src/util/Makefile.am
===================================================================
--- branches/new_class_id/src/util/Makefile.am	(revision 9707)
+++ branches/new_class_id/src/util/Makefile.am	(revision 9709)
@@ -4,5 +4,5 @@
 noinst_LIBRARIES = libORXutils.a
 
-libORXutils_a_SOURCES = fast_factory.cc \
+libORXutils_a_SOURCES = \
 			object_manager.cc \
 			state.cc \
@@ -31,5 +31,5 @@
 			track/track_node.cc
 
-noinst_HEADERS =        fast_factory.h \
+noinst_HEADERS =        \
 			object_manager.h \
 			state.h \
Index: branches/new_class_id/src/util/kill_target.cc
===================================================================
--- branches/new_class_id/src/util/kill_target.cc	(revision 9707)
+++ branches/new_class_id/src/util/kill_target.cc	(revision 9709)
@@ -23,6 +23,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(KillTarget, CL_KILL_TARGET);
 NewObjectListDefinitionID(KillTarget, CL_KILL_TARGET);
+CREATE_FACTORY(KillTarget);
 
 
Index: branches/new_class_id/src/util/multiplayer_team_deathmatch.cc
===================================================================
--- branches/new_class_id/src/util/multiplayer_team_deathmatch.cc	(revision 9707)
+++ branches/new_class_id/src/util/multiplayer_team_deathmatch.cc	(revision 9709)
@@ -50,6 +50,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(MultiplayerTeamDeathmatch, CL_MULTIPLAYER_TEAM_DEATHMATCH);
 NewObjectListDefinitionID(MultiplayerTeamDeathmatch, CL_MULTIPLAYER_TEAM_DEATHMATCH);
+CREATE_FACTORY(MultiplayerTeamDeathmatch);
 /**
  * constructor
Index: branches/new_class_id/src/util/singleplayer_shootemup.cc
===================================================================
--- branches/new_class_id/src/util/singleplayer_shootemup.cc	(revision 9707)
+++ branches/new_class_id/src/util/singleplayer_shootemup.cc	(revision 9709)
@@ -26,6 +26,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(SingleplayerShootemup, CL_SINGLEPLAYER_SHOOTEMUP);
 NewObjectListDefinitionID(SingleplayerShootemup, CL_SINGLEPLAYER_SHOOTEMUP);
+CREATE_FACTORY(SingleplayerShootemup);
 
 /**
